
!AJx86Assembler methodsFor: '*P4-Extension' stamp: 'CamilloBruni 4/3/2012 15:06'!
callRegister: num of: argSize
	num <= self callRegisterSize 
		ifTrue: [ ^ self callRegisters at: num ].
	
	^ self stackPointer accessAt: (num - self callRegisterSize - 1) * self pointerSize! !

!AJx86Assembler methodsFor: '*P4-Extension' stamp: 'CamilloBruni 4/3/2012 15:06'!
callRegisterSize
	^ self callRegisters size! !

!AJx86Assembler methodsFor: '*P4-Extension' stamp: 'CamilloBruni 4/3/2012 15:07'!
callRegisters
	^ {RDI. RSI. RDX. RCX. R8. R9}! !

!AJx86Assembler methodsFor: '*P4-Extension' stamp: 'CamilloBruni 4/3/2012 15:03'!
createStream
	^ P4LittleEndianWriteStream new
		wordSize: self wordSize;
		pointerSize: self pointerSize! !

!AJx86Assembler methodsFor: '*P4-Extension' stamp: 'CamilloBruni 6/1/2012 14:04'!
externalReference: label
	self flag: 'TODO: fix'.
	^ P4ASMExternalReference new label: label! !

!AJx86Assembler methodsFor: '*P4-Extension' stamp: 'CamilloBruni 4/3/2012 15:08'!
extraRegisters
	^ {RBX. RBP. R12. R13. R14. R15}! !

!AJx86Assembler methodsFor: '*P4-Extension' stamp: 'CamilloBruni 6/15/2012 18:20'!
finalize
	self halt.
"	linker danglingReferences keysAndValuesDo: [ :function :positions |
		self haltIf: function isSymbol not.
		positions do: [ :position | installer installFunction: function at: position ]].
	linker danglingReferences removeAll."! !

!AJx86Assembler methodsFor: '*P4-Extension' stamp: 'CamilloBruni 4/3/2012 15:08'!
intermediateRegisters 
	^ {R10. R11.}! !

!AJx86Assembler methodsFor: '*P4-Extension' stamp: 'CamilloBruni 4/3/2012 15:05'!
machOCPUSubType
	^ P4MOCPUSubType X86_ALL! !

!AJx86Assembler methodsFor: '*P4-Extension' stamp: 'CamilloBruni 4/3/2012 15:04'!
machOCPUType
	^ P4MOCPUType X86! !

!AJx86Assembler methodsFor: '*P4-Extension' stamp: 'CamilloBruni 4/3/2012 15:04'!
machOMagic
	^ P4MOMagic MAGIC32! !

!AJx86Assembler methodsFor: '*P4-Extension' stamp: 'CamilloBruni 4/20/2012 15:21'!
reference: label
	self flag: 'TODO: fix it'.
	^ P4ASMReference  
		target: (self labelNamed: label asString)
		label: label! !

!AJx86Assembler methodsFor: '*P4-Extension' stamp: 'CamilloBruni 4/4/2012 19:12'!
resultVariable 
	^ RAX! !

!AJx86Assembler methodsFor: '*P4-Extension' stamp: 'CamilloBruni 4/3/2012 15:09'!
volatileRegisters
	^ {RDX. RCX. RSI. RDI. R8. R9. }! !

!Class methodsFor: '*P4-Extension' stamp: 'ToonVerwaest 7/21/2011 17:23'!
asPClass
	^ P4Package loadClass: self mapToPclass		
		
		
  ! !

!Class methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 7/6/2011 16:34'!
dumpGlobalOn: binaryOut
	^ self dumpOn: binaryOut! !

!Class methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 7/6/2011 16:34'!
dumpLocalOn: binaryOut
	^ binaryOut postpone: self  ! !

!RBProgramNode methodsFor: '*P4-Extension' stamp: 'CamilloBruni 2/3/2012 16:48'!
acceptIgnoreResult: aProgramVisitor
	^ self accept: aProgramVisitor! !

!RBProgramNode methodsFor: '*P4-Extension' stamp: 'CamilloBruni 12/14/2011 16:16'!
isDynamic
	^ true! !

!RBProgramNode methodsFor: '*P4-Extension' stamp: 'CamilloBruni 12/14/2011 16:18'!
isSuper
	^ false! !

!CompiledMethod methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 8/18/2011 13:41'!
earlySelectorAddress
	| realSelector |
	(self pragmaAt: #globalName: ) ifNotNil: [ :pragma |
		^ pragma argumentAt: 1 ].
	
	(self pragmaAt: #renameExport: ) 
		ifNil: [ realSelector := self selector ]
		ifNotNil: [ :pragma | realSelector := pragma argumentAt: 1 ].

	^ (self pMethodClass pExportedName, '__', realSelector) asSymbol! !

!CompiledMethod methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 8/18/2011 13:42'!
pMethodClass 
	^ self methodClass asPClass! !

!String class methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 5/5/2011 16:33'!
newFromAll: strings 
	| size result position |
	size := 0.
	strings
		do: [:s | size := size + s size].
	result := self new: size.
	position := 1.
	strings
		do: [:s | s
				do: [:c | 
					result at: position put: c.
					position := position + 1]].
	^ result! !

!Symbol methodsFor: '*P4-Extension' stamp: 'ToonVerwaest 7/23/2011 18:57'!
pHash
	| hash maxInt |
	self flag: 'Not a super fast implementation; but it matches what we have in C...'.
	maxInt := (1 bitShift: 64) - 1.
	hash := 5381.
	1 to: self size do: [ :i |
		hash := (hash + ((hash bitShift: 5) bitAnd: maxInt) + (self at: i) asInteger) bitAnd: maxInt ].
	((hash bitShift: -63) bitAnd: 1) = 1 ifTrue: [ hash := hash bitShift: -1].
	^ hash! !

!Metaclass methodsFor: '*P4-Extension' stamp: 'ToonVerwaest 7/21/2011 17:34'!
asPClass
	^ thisClass asPClass pclass! !

!Metaclass methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 8/18/2011 13:39'!
earlySelectorAddress: aSelector
	| method |
	method := self pLookupSelector: aSelector.
	^ method earlySelectorAddress.! !

!Metaclass methodsFor: '*P4-Extension' stamp: 'ToonVerwaest 7/21/2011 17:23'!
mapToPclass
	^ thisClass mapToPclass class! !

!Metaclass methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 7/20/2011 16:07'!
p4super
	self == P4Object class ifTrue: [ ^ P4Class ].
	^ self super! !

!Metaclass methodsFor: '*P4-Extension' stamp: 'ToonVerwaest 7/21/2011 18:25'!
pInstSize
	^ self instSize - P4Object class instSize + P4Class instSize! !

!Behavior methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 8/29/2011 11:57'!
mapToPclass
	^ {
	
	Object 				-> P4Object. 
	Behavior 			-> P4Behavior.
	Metaclass 			-> P4Metaclass.
	Class 				-> P4Class.
	IdentityDictionary 	-> P4IdentityDictionary.
	Dictionary 			-> P4Dictionary.
	Array 				-> P4Array.
	ByteSymbol 		-> P4Symbol.
	ByteString 			-> P4String.
	UndefinedObject 	-> P4UndefinedObject.
	True 				-> P4True.
	False 				-> P4False.
	SmallInteger 		-> P4SmallInteger.
	
	} asDictionary at: self ifAbsent: [ self error: 'Trying to export invalid class' ]
		
  ! !

!Behavior methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 8/18/2011 13:46'!
pLookupSelector: aSelector
	| method |
	method := self lookupSelector: aSelector.
	^ (method methodClass mapToPclass methodDict) 	at: aSelector! !

!RBLiteralNode methodsFor: '*P4-Extension' stamp: 'CamilloBruni 12/14/2011 16:16'!
isDynamic
	^ false! !

!Boolean methodsFor: '*P4-Extension' stamp: 'ToonVerwaest 7/18/2011 17:08'!
dumpGlobalOn: executableFormat
	^ self dumpOn: executableFormat.! !

!Boolean methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 7/6/2011 16:59'!
dumpLocalOn: executableFormat
	^ executableFormat postpone: self! !

!Boolean methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 7/15/2011 14:51'!
pExportedName 
	^ self name asSymbol! !

!SmallInteger methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 7/6/2011 18:20'!
asTaggedInteger 
	^ 1+(self bitShift: 1)! !

!SmallInteger methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 10/4/2011 15:58'!
pHash 
	^ self! !

!RBAssignmentNode methodsFor: '*P4-Extension' stamp: 'CamilloBruni 2/3/2012 16:48'!
acceptIgnoreResult: visitor
	^ visitor visitAssignmentStatement: self! !

!RBVariableNode methodsFor: '*P4-Extension' stamp: 'CamilloBruni 12/14/2011 16:16'!
isDynamic
	^ false! !

!RBVariableNode methodsFor: '*P4-Extension' stamp: 'CamilloBruni 12/14/2011 16:18'!
isSuper
	^ self name = 'super'! !

!UndefinedObject methodsFor: '*P4-Extension' stamp: 'ToonVerwaest 7/18/2011 17:09'!
dumpGlobalOn: executableFormat
	^ self dumpOn: executableFormat.! !

!UndefinedObject methodsFor: '*P4-Extension' stamp: 'ToonVerwaest 7/19/2011 00:20'!
dumpLocalOn: executableFormat
	^ executableFormat postpone: self! !

!UndefinedObject methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 7/15/2011 14:47'!
pExportedName 
	^ #nil! !

!ByteSymbol methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 7/15/2011 16:35'!
dumpLocalOn: binaryOut
	^ binaryOut symbol: self  ! !

!ByteSymbol methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 7/15/2011 17:36'!
pExportedName 
	^('s_', self) asSymbol! !

!AJX86GPRegister methodsFor: '*P4-Extension' stamp: 'CamilloBruni 4/3/2012 15:39'!
accessAt: offset
	^ P4ASMRegisterAccess new
		register: self;
		offset: offset! !

!AJX86GPRegister methodsFor: '*P4-Extension' stamp: 'CamilloBruni 4/3/2012 15:39'!
isAccess
	^ true! !

!AJX86GPRegister methodsFor: '*P4-Extension' stamp: 'CamilloBruni 4/3/2012 15:38'!
pop
	^ P4TACPop register: self! !

!AJX86GPRegister methodsFor: '*P4-Extension' stamp: 'CamilloBruni 4/3/2012 15:38'!
push
	^ P4TACPush register: self! !

!Object class methodsFor: '*P4-Extension' stamp: 'ToonVerwaest 5/16/2011 18:48'!
pname
	^ self name! !

!Object methodsFor: '*P4-Extension' stamp: 'CamilloBruni 4/3/2012 14:53'!
dump: var on: binaryOut for: aReference at: offset
	| instVarReference |
	
	(var isKindOf: SmallInteger) ifTrue: [	
		binaryOut pointerPut: var asTaggedInteger at: aReference pointerOffset: offset-1.
		^ self ].

	instVarReference := binaryOut localDump: var.
	binaryOut pointerPut: instVarReference addend at: aReference pointerOffset: offset - 1.
 	binaryOut referTo: instVarReference at: aReference pointerOffset: offset-1.
! !

!Object methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 7/6/2011 16:13'!
dumpGlobalOn: binaryOut
	self error: 'not a global object'  ! !

!Object methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 7/6/2011 18:39'!
dumpLocalOn: binaryOut
	^ self dumpOn: binaryOut! !

!Object methodsFor: '*P4-Extension' stamp: 'ToonVerwaest 7/19/2011 12:59'!
dumpOn: binaryOut
	| myRef var |
	myRef := binaryOut allocate: self.
	
	1 to: self pclass pInstSize do: [ :i |
		var := self pInstVarAt: i.
		self dump: var on: binaryOut for: myRef at: i ].
	
	1 to: self pVariableSize do: [ :i |
		var := self pVariableAt: i.
		self dump: var on: binaryOut for: myRef at: i+self pclass pInstSize ].
	
	^ myRef
! !

!Object methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 7/8/2011 12:36'!
flush
! !

!Object methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 7/14/2011 15:30'!
pByteAt: i
	^ self basicAt: i    ! !

!Object methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 7/14/2011 16:47'!
pByteName
	^ nil! !

!Object methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 7/14/2011 15:34'!
pByteSize 
	self class isBytes 
		ifTrue: [ ^ self basicSize ].
	^ 0! !

!Object methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 7/15/2011 14:50'!
pExportedName 
	^ nil! !

!Object methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 10/4/2011 15:49'!
pHash
	^ self hash! !

!Object methodsFor: '*P4-Extension' stamp: 'ToonVerwaest 7/23/2011 18:39'!
pHeader
	| base variable bytes hash |
	base := self pclass pInstSize.
	variable := self pclass pIsVariable ifTrue: [ 1 ] ifFalse: [ 0 ].
	bytes := self pclass pIsBytes ifTrue: [ 1 ] ifFalse: [ 0 ].
	hash := self identityHash.
	^ (hash bitShift: 12) + (bytes bitShift: 9) + (variable bitShift: 8) + base! !

!Object methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 7/14/2011 15:23'!
pInstSize 
	^ self instSize ! !

!Object methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 7/14/2011 15:35'!
pInstVarAt: i
	^ self instVarAt: i  ! !

!Object methodsFor: '*P4-Extension' stamp: 'ToonVerwaest 7/19/2011 18:26'!
pIsBytes
	^ self isBytes! !

!Object methodsFor: '*P4-Extension' stamp: 'ToonVerwaest 7/19/2011 18:32'!
pIsVariable
	^ self isBytes not and: [ self isVariable ]! !

!Object methodsFor: '*P4-Extension' stamp: 'ToonVerwaest 7/21/2011 18:04'!
pIsVariableOrBytes
	^ self isVariable! !

!Object methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 7/14/2011 15:30'!
pVariableAt: i
	^ self basicAt: i    ! !

!Object methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 7/14/2011 15:34'!
pVariableSize 
	self class isBytes 
		ifFalse: [ ^ self basicSize ].
	^ 0! !

!Object methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 7/14/2011 15:19'!
pVariableSizeHeader 
	^ self basicSize ! !

!Object methodsFor: '*P4-Extension' stamp: 'ToonVerwaest 7/21/2011 17:33'!
pclass
	^ self class asPClass! !

!Object methodsFor: '*P4-Extension' stamp: 'OliFlueckiger 8/5/2011 18:40'!
printObj
	<preventExport>! !
